<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="项目名称:">
                <Input v-model="formObj.projectName" @on-enter="_formSearch" name="projectName" placeholder="请输入项目名称" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                     class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}</span>
                  <div v-else-if="item.detail">
                    <a @click.stop="_detailModal(scope.row)">{{ scope.row[item.key] }}</a>
                  </div>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <keep-alive>
      <!-- eslint-disable-next-line vue/require-component-is -->
      <component ref="refModal" :is="currentComponent" @on-result-change="_componentResult"></component>
    </keep-alive>
  </div>
</template>
<script>
import { soilEntrust, soilSample } from '../../api'
import Operation from '../../components/operation/Operation'
import importModal from '../../components/import/DownloadTemplateImport'
import EntrustRegisterEdit from './EntrustRegisterEdit'
import RegisterDetail from './RegisterDetail'
import ViewDetail from './ViewDetail'
export default {
  components: {
    // eslint-disable-next-line vue/no-unused-components
    Operation,
    // eslint-disable-next-line vue/no-unused-components
    EntrustRegisterEdit,
    // eslint-disable-next-line vue/no-unused-components
    importModal,
    // eslint-disable-next-line vue/no-unused-components
    RegisterDetail,
    // eslint-disable-next-line vue/no-unused-components
    ViewDetail
  },
  data() {
    return {
      currentComponent: '',
      formId: 'meterSubcontractorFormId',
      searchOpen: false,
      btn: [
        {
          type: 'success',
          id: '',
          name: '登记'
        },
        {
          type: 'success',
          id: '',
          name: '提交'
        }
      ],
      iconMsg: [
        {
          type: 'md-create',
          id: '',
          name: '编辑'
        },
        {
          type: 'ios-list',
          id: '',
          name: '查看'
        },
        {
          type: 'md-cloud',
          id: '',
          name: '附件'
        },
        {
          type: 'md-remove-circle',
          id: '',
          name: '删除'
        }
      ],
      formObj: {
        client: undefined,
        contractCode: undefined,
        entrustCode: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '项目名称', key: 'projectName', width: 120 },
        { title: '项目负责人', key: 'projectLeader', width: 150, detail: true },
        { title: '钻孔名称', key: 'boreholeName', width: 120 },
        { title: '箱数', key: 'casesNum', width: 120 },
        { title: '登记日期', key: 'registTime', width: 120, date: true }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {},
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '试验委托单导入':
            this._import()
            break
          case '登记':
            this._editModal(false)
            break
          case '提交':
            this._submitToInstock()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _detailModal(data) {
      console.log(data)
      this._getUserInfo(data)
      this.currentComponent = 'RegisterDetail'
    },
    _getUserInfo: async function(data) {
      const result = await soilEntrust.getUserByGroupId({
        realname: data.projectLeader,
        id: data.projectLeaderId
      })
      if (result) {
        this.$refs.refModal._open(result)
      }
    },
    _import() {
      this.currentComponent = 'importModal'
      const data = {
        importUrl: '/soil/v1/entrust/import_entrust/',
        downloadUrl: '/soil/v1/excel/template/SoilEntrustImport',
        title: '试验委托单导入'
      }
      this.$nextTick(() => {
        this.$refs.refModal._open(data, '试验委托单导入')
      })
    },
    _componentResult(msg, data) {
      switch (this.currentComponent) {
        case 'MeterSubcontractorEdit':
          this._formSearch()
          break
        case 'DrugSampleManage':
          this._formSearch()
          break
        case 'FileManage':
          this._fileResult(msg, data)
          break
        default:
          this._page()
      }
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '编辑':
            this._editModal(true, data.id)
            break
          case '查看':
            this._viewModal(true, data.id)
            break
          case '试样列表':
            this._sampleManage(data.id)
            break
          case '试验项目列表':
            this._itemManage(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },

    _sampleManage(data) {
      // 管理样品
      this.currentComponent = 'SoilSampleManage'
      this.$nextTick(() => {
        this.$refs.refModal._open(data)
      })
    },
    _itemManage(data) {
      // 管理样品
      this.currentComponent = 'SoilSampleItemManage'
      this.$nextTick(() => {
        this.$refs.refModal._openByEntrustId(data)
      })
    },
    _submitToInstock() {
      this._submitByContractIds('入库')
    },
    _submitToSkipReview() {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要提交 ' + ids.length + ' 条记录？',
          onOk: () => {
            this.$refs.pageTable._showLoading()
            this._subToSkipRe(ids)
          }
        })
      }
    },
    _submitByContractIds(cont) {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要把这 ' + ids.length + ' 条记录提交到' + cont + '？',
          onOk: () => {
            this.$refs.pageTable._showLoading()
            this._subToRe(ids)
          }
        })
      }
    },
    _subToRe: async function(ids) {
      const result = await soilEntrust.submitToInstock({ ids: ids.join(',') })
      if (result) {
        this._resultChange('提交成功')
      }
    },
    _subToSkipRe: async function(ids) {
      const result = await soilEntrust.submitSkipReview(ids)
      if (result) {
        this._resultChange('提交成功')
      }
    },
    _resultChange(msg) {
      this.$Message.success(msg)
      this._page()
      this.$refs.pageTable._hideLoading()
    },
    _record(id) {
      this.currentComponent = 'Operation'
      this.$nextTick(() => {
        this.$refs.refModal._open(id)
      })
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectIds':
          this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'page':
          this._page()
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await soilSample.aloneSamplePage(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      this.currentComponent = 'EntrustRegisterEdit'
      if (edit) {
        this.$refs.pageTable._showLoading()
        // 编辑
        this._getById(id)
      } else {
        // 添加
        this.$nextTick(() => {
          this.$refs.refModal._open()
        })
      }
    },
    _viewModal(edit, id) {
      this.currentComponent = 'ViewDetail'
      if (edit) {
        this.$refs.pageTable._showLoading()
        // 编辑
        this._getDetailById(id)
      } else {
        // 添加
        this.$nextTick(() => {
          this.$refs.refModal._open()
        })
      }
    },
    _getDetailById: async function(id) {
      const result = await soilEntrust.aloneSampleGetById(id)
      if (result) {
        this.$refs.refModal._open(result)
        this.$refs.pageTable._hideLoading()
      } else {
        this.$refs.pageTable._hideLoading()
      }
    },
    _upload(id) {
      // 上传文件
      this.currentComponent = 'FileManage'
      this.$nextTick(() => {
        this.$refs.refModal._open(id, 'aloneSampleId')
      })
    },
    _getById: async function(id) {
      const result = await soilEntrust.aloneSampleGetById(id)
      if (result) {
        this.$refs.refModal._openEdit(result)
        this.$refs.pageTable._hideLoading()
      } else {
        this.$refs.pageTable._hideLoading()
      }
    },
    _delete: async function(ids) {
      const result = await soilEntrust.aloneSampleDelete(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
